<script setup lang="ts">
import { computed, ref } from "vue";
import { useStore } from "vuex";
import useSorting from "@/composables/useSorting";
import SortItem from "@/components/SortItem.vue";
import BoxItem from "@/components/BoxItem.vue";
import { Stop } from "@/types/Stop";
import { SortType } from "@/types/SortType";

const store = useStore()
const { sort } = useSorting()
const searchQuery = ref("")
const searchResult = ref("")
let timeout = 0

const onSearchChange = () => {
	clearTimeout(timeout)
	timeout = setTimeout(() => {
		performSearch(searchQuery.value)
	}, 300)
}

const performSearch = (query: string) => {
	searchResult.value = query
}

const filteredList = computed(() =>
	store.state.stops.filter((stop: Stop) => {
		if (searchResult.value) {
			return stop.stop.toLowerCase().includes(searchResult.value.toLowerCase());
		}
		return stop;
	})
);

const sortAllBusStops = () => {
	sort((type: SortType) => {
		store.commit("sortAllBusStops", type);
	});
}
</script>

<template>
	<div class="row stops-view">
		<div class="col col-12">
			<div class="row p-2 gap-4 bg-white app-rounded">
				<div class="col col-12">
					<div class="form-group">
						<input v-model="searchQuery" @input="onSearchChange" type="text" class="search form-control" />
					</div>
				</div>
				<div class="col col-12">
					<SortItem title="Bus Stops" @click="sortAllBusStops" />
				</div>
				<hr class="m-0" />
				<div class="col col-12">
					<ul class="stops-view__list">
						<BoxItem
								v-for="(stop, index) in filteredList"
								:key="stop + index"
								:title="`${ stop.stop } ${ stop.order }`"
						/>
					</ul>
				</div>
			</div>
		</div>
	</div>
</template>

<style scoped lang="scss">
.search {
	width: 288px;
	height: 40px;
	border-color: #1952E1;
}
</style>
